<template>
  <user-center-layout :title="$t('bet_history')" class="bet-history">
    <div class="w-full relative h-full flex justify-center items-center" v-if="availableTabs.length <= 0">
      <utils-not-found />
    </div>
    <div class="w-full relative mx-auto bet-history-page" v-else>
      <el-tabs v-model="activeTab" class="demo-tabs" @tab-click="handleClick">
        <el-scrollbar>
          <div class="pt-6 flex items-center gap-4">
            <div class="flex flex-row items-center gap-2">
              <div>{{ $t("provider") }}</div>
              <el-select
                v-model="selectedProvider"
                :placeholder="$t('select')"
                class="mx-1 w-24"
                :disabled="disableSelect"
              >
                <el-option
                  v-for="provider in gameProviders"
                  :key="provider.GameProviderId"
                  :label="provider.GameProviderName === 'All' ? $t(provider.GameProviderName) : provider.GameProviderName"
                  :value="provider.GameProviderId"
                />
              </el-select>
            </div>
            <div class="flex flex-row items-center">
              <div
                v-show="isSportType"
                class="flex flex-row items-center gap-2"
              >
                <div>{{ $t("status") }}</div>
                <el-select
                  v-model="selectedSportStatus"
                  :placeholder="$t('status')"
                  class="mx-1 w-24"
                >
                  <el-option
                    v-for="(item, index) in allSportStatus"
                    :key="index"
                    :label="$t(item)"
                    :value="item"
                  />
                </el-select>
              </div>
              <date-picker-datetime-range-selector-desktop
                :disabled="selectedSportStatus === 'Running' && isSportType"
                v-model:startDate="selectedStartDate"
                v-model:endDate="selectedEndDate"
                :number-date-for-disable="60"
              />
            </div>
            <div class="w-[2px] h-[16px] bg-[var(--border)]"></div>
            <el-button
              :disabled="isLoading"
              class="!py-2 !px-4 !rounded-2xl"
              type="primary"
              @click="onSearch"
              >{{ $t("search") }}</el-button
            >
          </div>
        </el-scrollbar>
        <el-tab-pane :label="$t('sports')" :name="BET_HISTORY_TAB.SPORT" v-if="availableTabs.includes('sports')">
          <desktop-bet-details-sport-bet
            :key="BET_HISTORY_TAB.SPORT"
            v-loading="isLoading"
            :is-settled="true"
            :sport-bet="sportBetListDisplay"
            :on-display-bet-detail="onDisplayBetDetail"
          />
        </el-tab-pane>
        <el-tab-pane
          :label="$t('virtual_sports')"
          :name="BET_HISTORY_TAB.VIRTUAL_SPORT"
          v-if="availableTabs.includes('virtual_sports')">
          <desktop-bet-details-sport-bet
            :key="BET_HISTORY_TAB.VIRTUAL_SPORT"
            v-loading="isLoading"
            :is-settled="true"
            :sport-bet="sportBetListDisplay"
            :on-display-bet-detail="onDisplayBetDetail"
          />
        </el-tab-pane>
        <el-tab-pane :label="$t('live_casino')" :name="BET_HISTORY_TAB.CASINO" v-if="availableTabs.includes('live_casino')">
          <desktop-bet-details-game-bet
            :key="BET_HISTORY_TAB.CASINO"
            v-loading="isLoading"
            :game-bet="gameBetListDisplay"
            :on-display-bet-detail="onDisplayBetDetail"
          />
        </el-tab-pane>
        <el-tab-pane :label="$t('games')" :name="BET_HISTORY_TAB.GAME_BET" v-if="availableTabs.includes('games')">
          <desktop-bet-details-game-bet
            :key="BET_HISTORY_TAB.GAME_BET"
            v-loading="isLoading"
            :game-bet="gameBetListDisplay"
            :on-display-bet-detail="onDisplayBetDetail"
          />
        </el-tab-pane>
        <el-tab-pane
          :label="$t('cock_fight')"
          :name="BET_HISTORY_TAB.COCKFIGHT"
          v-if="availableTabs.includes('cock_fight')">
          <desktop-bet-details-game-bet
            :key="BET_HISTORY_TAB.COCKFIGHT"
            v-loading="isLoading"
            :game-bet="gameBetListDisplay"
            :on-display-bet-detail="onDisplayBetDetail"
          />
        </el-tab-pane>
        <el-tab-pane :label="$t('poker')" :name="BET_HISTORY_TAB.POKER" v-if="availableTabs.includes('poker')">
          <desktop-bet-details-game-bet
            :key="BET_HISTORY_TAB.POKER"
            v-loading="isLoading"
            :game-bet="gameBetListDisplay"
            :on-display-bet-detail="onDisplayBetDetail"
          />
        </el-tab-pane>
        <el-tab-pane :label="$t('lottery')" :name="BET_HISTORY_TAB.LOTTERY" v-if="availableTabs.includes('lottery')">
          <desktop-bet-details-game-bet
            :key="BET_HISTORY_TAB.LOTTERY"
            v-loading="isLoading"
            :game-bet="gameBetListDisplay"
            :on-display-bet-detail="onDisplayBetDetail"
          />
        </el-tab-pane>
      </el-tabs>
      <div class="flex items-center justify-between px-6">
        <div class="flex items-center time-notice-footer">
          <el-icon class="mx-1">
            <clock />
          </el-icon>
          <p>{{ $t("All_transactions_are_time_stamped_at_GMT-4") }}</p>
        </div>
        <div>
          <el-pagination
            v-model:current-page="currentPage"
            :pager-count="4"
            :total="totalBetList"
            :page-size="totalBetPerPage"
            background
            layout="prev, pager, next"
          />
        </div>
      </div>
    </div>
  </user-center-layout>
</template>
<script lang="ts" setup>
import { Clock, Search } from "@element-plus/icons-vue";
import { SportBet } from "~~/models/sportbet/sportbet";
import { SeamlessGameBet } from "~~/models/seamlessGameBets";

const {
  gameBetList,
  sportBetList,
  gameProviders,
  selectedProvider,
  activeTab,
  onSearch,
  disableSelect,
  currentPage,
  totalBetList,
  totalBetPerPage,
  isLoading,
  selectedStartDate,
  selectedEndDate,
  selectedSportStatus,
  allSportStatus,
  isSettled,
  isSportType,
  onDisplayBetDetail,
  allTabs,
} = useBetHistory();
defineProps({
  containerClass: {
    type: String,
    default: "",
  },
});

const sportBetListDisplay = computed(() =>
  sportBetList.value.map((sb) => new SportBet(sb))
);
const gameBetListDisplay = computed(() =>
  gameBetList.value.map((gb) => new SeamlessGameBet(gb))
);
const availableTabs = computed(()=>allTabs.value.map((tabInfo) => tabInfo.TabLanguage));
</script>
<style scoped>
.bet-history-page {
  padding-bottom: 1rem;
}

:deep(.bet-history-page .el-tabs__content) {
  padding-left: 1.5rem;
  padding-right: 1.5rem;
}

:deep(.el-pagination.is-background .el-pager li:not(.is-disabled).is-active) {
  background-color: transparent;
  color: var(--el-color-primary);
  font-weight: 700;
  border: 1px solid var(--el-color-primary);
  border-radius: px;
}
:deep(.el-pagination.is-background .el-pager li) {
  background-color: transparent;
}
:deep(.el-pagination.is-background .btn-prev) {
  background-color: transparent;
}
:deep(.el-pagination.is-background .btn-next) {
  background-color: transparent;
}
</style>
